#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/sendfile.h>

int main(int argc, const char *argv[]) {
  if (argc < 3) {
    printf("Usage: %s <source> <destination>", argv[0]);
    return 1;
  }

  const char *srcPath = argv[1];
  const char *dstPath = argv[2];

  struct stat srcStat;
  if (stat(srcPath, &srcStat) < 0) {
    perror("stat source file");
    return 2;
  }

  int fromFd = open(argv[1], O_RDONLY);
  if (fromFd < 0) {
    perror("open source file");
    return 2;
  }

  int toFd = open(argv[2], O_CREAT|O_WRONLY|O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
  if (toFd < 0) {
    perror("open destination file");
    return 2;
  }

  sendfile(toFd, fromFd, NULL, srcStat.st_size);

  return 0;
}

